(* (c) by Richard Lang
   collecting all knowledge for Root and Rational Equations
   created by: rlang 
         date: 02.10
   changed by: rlang
   last change by: rlang
             date: 02.11.04
*)

(* use"knowledge/RootRatEq.ML";
   use"RootRatEq.ML";

   use"ROOT.ML";
   cd"knowledge";

   remove_thy"RootRatEq";
   use_thy"Isac";
   *)

RootRatEq = RootEq + RatEq + RootRat + 

(*-------------------- consts-----------------------------------------------*)
consts

  is'_ratrootaddeq'_in :: [real, real] => bool ("_ is'_ratrootaddeq'_in _") 

(*---------scripts--------------------------*)
  Elim'_rootrat'_equation
             :: "[bool,real, \
		  \ bool list] => bool list"
               ("((Script Elim'_rootrat'_equation (_ _ =))// \
                 \ (_))" 9)
 (*-------------------- rules------------------------------------------------*)
rules

  (* eliminate ratRootEquation *)
  rootrat_equation_left
   "[|c is_rootequation_in bdv|] ==> ( (a + b/c = d) = ( b = (d - a) * c ))"
  rootrat_equation_right
   "[|f is_rootequation_in bdv|] ==> ( (a = d + e/f) = ( (a - d) * f = e ))"



end
