(* use"Isa99/ListG.ML";
   W.N. 8.01
*)



theory' := overwritel (!theory', 
  [("ListG.thy",ListG.thy)]);
(*rule set for listexpr in scripts:
  in knowledge/interface_ME_ISA.sml .. needs eval_binop from Atools.ML
*)
theorem' := overwritel (!theorem',
  [("length_Cons_",num_str length_Cons_),
(*   ("",num_str ),
   ("",num_str ),
   ("",num_str ),
   ("",num_str ),
*)
   ("length_Nil_",num_str length_Nil_)]);

(*Length; could be done on the object-level*)
(*("Length",("Tools.Length",eval_Length "#Length_")):calc*)
fun eval_Length (thmid:string) (op_:string) 
  (t as (Const(op0,t0) $ arg)) thy = 
  let 
    val t' = ((term_of_num HOLogic.realT) o length o isalist2list) arg;
    val thmId = thmid^(Sign.string_of_term (sign_of thy) arg);
  in Some (thmId, Trueprop $ (mk_equality (t,t'))) end
  | eval_Length _ _ _ _ = None;

(*Nth; could be done on the object-level*)
(*("Nth"   ,("Tools.Nth",eval_Nth "#Nth_")):calc*)
fun eval_Nth (thmid:string) (op_:string) 
  (t as (Const (op0,t0) $ t1 $ t2 )) thy =
  if is_num t1 andalso is_list t2
    then
      (let 
	val t' = (nth (num_of_term t1) (isalist2list t2))
	val thmId = thmid^(Sign.string_of_term (sign_of thy) t1)^
	  "_"^(Sign.string_of_term (sign_of thy) t2)^
	  " = "^(Sign.string_of_term (sign_of thy) t');
      in Some (thmId, Trueprop $ (mk_equality (t,t'))) end)
	  handle _ => None (*31.8.01: strange??*)
  else None
  | eval_Nth _ _ _ _ = None;

(*19.9.02----------------------------
calc_list:= overwritel (! calc_list,
            [
	     ]);
-------------------------------------*)