(* 28.8.02: eval_true_ -> ... -> TRUE | FALSE | INDETerminate
            SqRoot_simplify terminiert nicht mehr ?! siehe test-rootequ.sml
            aufheben !!! (nehmen, sobald -"- untersucht)

   use"../Isa02/interface_ME_ISA_tools.sml";
   use"Isa02/interface_ME_ISA_tools.sml";
   use"interface_ME_ISA_tools.sml";
   *)


datatype det = TRUE | FALSE | INDET;
fun determine dts =
    let val false_indet = 
	    filter_out ((curry op= TRUE) o (#1:det * term -> det)) dts
        val ts = map (#2: det * term -> term) dts
    in if nil = false_indet then (TRUE, ts)
       else if nil = filter ((curry op= FALSE) o (#1:det * term -> det))
			    false_indet
       then (INDET, ts)
       else (FALSE, ts) end;
(* val dts = [(INDET,e_term), (FALSE,HOLogic.false_const), 
	      (INDET,e_term), (TRUE,HOLogic.true_const)];
  determine dts;
val it =
  (FALSE,
   [Const ("empty","'a"),Const ("False","bool"),Const ("empty","'a"),
    Const ("True","bool")]) : det * term list*)

exception NO_REWRITE;

(*val tthy = ref Main.thy;
val ttless = ref termless;
val trls = ref empty_rls;
val tput_asm = ref false;
val tthm = ref refl;
val tct = ref ((the o (parse thy)) "#1+#1+#1");
val truless = ref empty_rls;*)

(*17.6.00: rewrite by going down the term with rew_sub*)
fun rewrite_ thy tless rls put_asm thm ct =
( (* rewrite_ (!tthy) (!ttless) (!trls) (!tput_asm) (!tthm) (!tct);
*)
(*tthy    := thy;
ttless  := tless;
trls    := rls;
tput_asm:= put_asm;
tthm    := thm; 
tct     := ct;*)
  let
    val (t',asms,rew) = rew_sub thy tless rls put_asm 
      ((norm o #prop o rep_thm) thm) ct;
  in if rew then Some (t', asms)
     else None end
)(* val r = (norm o #prop o rep_thm) thm;val t = term_of ct;
    *)
and rew_sub thy tless rls put_asm r t = 
    (let                  (* see Pure/thm.ML: fun rewritec *)
	 val (lhs,rhs) = (dest_equals' o strip_trueprop 
			  o Logic.strip_imp_concl) r
	 val insts = Pattern.match (Sign.tsig_of(sign_of thy)) (lhs,t)
	 (*TODOtest: (-"-) handle _ => raise NO_REWRITE; 12.8.02 ???*)
	 val r' = ren_inst(insts,r,lhs,t)
	 val p' = map strip_trueprop (Logic.strip_imp_prems r') 
	 val t' = (snd o dest_equals' o strip_trueprop 
		   o Logic.strip_imp_concl) r'
	 val (t'',p'') =
	     (case eval_true_ thy p' rls of
		  (TRUE, _) => (t',[])
		| (INDET, _) => (t',p')
		| (FALSE, cs) => 
		  (if ! trace_rewrite 
		   then writeln("### prems false: "^
				(commas (map (Sign.string_of_term
						  (sign_of thy)) cs)))
		   else ();
		   raise NO_REWRITE))
     in if perm lhs rhs andalso not (tless(t',t)) 
	then (if ! trace_rewrite then 
		  writeln("### not: \""^
			  (Sign.string_of_term (sign_of thy) t)^"\" > \""^
			  (Sign.string_of_term (sign_of thy) t')^"\"") else (); 
	      raise NO_REWRITE )
	else (t'',p'',true)
     end) 
    handle _ (*TODOtest: NO_REWRITE *) => 
	   (case t of
		Const(s,T) => (Const(s,T),[],false)
	      | Free(s,T) => (Free(s,T),[],false)
	      | Var(n,T) => (Var(n,T),[],false)
	      | Bound i => (Bound i,[],false)
	      | Abs(s,T,body) => 
		let val (t',asms,rew) = rew_sub thy tless rls put_asm r body
		in (Abs(s,T,t'),asms,rew) end
	      | t1 $ t2 => 
		let val (t2',asm2,rew2) = rew_sub thy tless rls put_asm r t2
		in if rew2 then (t1 $ t2',asm2,true)
		   else let val (t1',asm1,rew1) = 
				rew_sub thy tless rls put_asm r t1
			in if rew1 then (t1' $ t2,asm1,true)
			   else (t1 $ t2,[],false) end
		end)
(* fn : theory -> term list -> rls -> bool 

> val (cprems',rls)=([cterm_of (sign_of thy) t],(the o assoc')(!ruleset',rls));
> eval_true_ thy cprems' rls;
> val cp=hd cprems';
> rewrite_set_ thy empty_rls false rls cp;
  *)
and eval_true_ thy cs rls =
if cs = [HOLogic.true_const] orelse cs = [] then (TRUE, [])
    else if cs = [HOLogic.false_const] then (FALSE, cs)
    else
	let fun eval t = 
		let val taopt = rewrite_set_ thy e_rls false rls t
		in case taopt of
		       Some (t,_) =>
		       if t = HOLogic.true_const then (TRUE, t)
		       else if t = HOLogic.false_const then (FALSE, t)
		       else (INDET, t)
		     | None => (INDET, t) end
	in (determine o (map eval)) cs end
and rewrite_set_ thy rls put_asm ruless ct =
    case ruless of
	Rrls {scr=Rfuns {normal_form=n,...},...} => n ct
      | Rls _ =>
  let
    datatype switch = Appl | Noap;
    fun rew_once ruls asm ct Noap [] = (ct,asm)
      | rew_once ruls asm ct Appl [] = rew_once ruls asm ct Noap ruls
      | rew_once ruls asm ct apno (rul::thms) =
      case rul of
	Thm (thmid, thm) =>
	  (if not (!trace_rewrite) then () else
	   writeln("### trying thm '"^thmid^"'");
	   case rewrite_ thy ((snd o #rew_ord o rep_rls) ruless) 
	     rls put_asm (thm_of_thm rul) ct of
	     None => rew_once ruls asm ct apno thms
	   | Some (ct',asm') => (if ! trace_rewrite 
	     then writeln("### rewrites to: "^
			  (Sign.string_of_term (sign_of thy) ct')) else ();
	       rew_once ruls (asm union asm') ct' Appl (rul::thms)))
      | Calc (cc as (op_,_)) => 
	  (if not (!trace_rewrite) then () else
	   writeln("### trying calc. '"^op_^"'");
	   case get_calculation_ thy cc ct of
	       None => rew_once ruls asm ct apno thms
	   | Some (thmid, thm') => 
	       let 
		 val pairopt = 
		   rewrite_ thy ((snd o #rew_ord o rep_rls) ruless) 
		   rls put_asm thm' ct;
		 val _ = if pairopt <> None then () 
			 else raise error("rewrite_set_, rewrite_ \""^
			 (string_of_thm thm')^"\" \""^
			 (Sign.string_of_term (sign_of thy) ct)^"\" = None")
		 val _ = if ! trace_rewrite 
			   then writeln("### calc. to: "^
					(Sign.string_of_term (sign_of thy)
					 ((fst o the) pairopt)))
			 else()
	       in rew_once ruls asm ((fst o the) pairopt) Appl(rul::thms) end);
    val ruls = (#rules o rep_rls) ruless;
    val (ct',asm') = rew_once ruls [] ct Noap ruls;
  in if ct = ct' then None else Some (ct',asm') end;

(*.variants of rewrite.*)
(*FIXME 12.8.02: put_asm = true <==> rewrite_inst,
  thus the argument put_asm  IS NOT NECESSARY -- FIXME*)
fun rewrite_inst_ (thy:theory) rew_ord (rls:rls) 
  (put_asm:bool) (subs':(cterm' * cterm') list) (thm:thm) (ct:term) =
  let (*
    val subs' = ((map (apfst (Sign.string_of_term (sign_of thy)))) 
		 o (map (apsnd (Sign.string_of_term (sign_of thy))))) subs;*)
    val subthm = read_instantiate subs' thm (*Pure/drule.ML*)
  in rewrite_ thy rew_ord rls put_asm subthm ct
  end;
fun rewrite_set_inst_ (thy:theory) (erls:rls) 
  (put_asm:bool) (subs':(cterm' * cterm') list) (rls:rls) (ct:term) =
  let (*
    val subs' = ((map (apfst (Sign.string_of_term (sign_of thy)))) 
		 o (map (apsnd (Sign.string_of_term (sign_of thy))))) subs;*)
    val subrls = instantiate_rls subs' rls
  in rewrite_set_ thy erls put_asm subrls ct
  end;



(*search ct for adjacent numerals and calculate them by op_*)
fun calculate_ thy op_ ct =
  let val isaop = (the (assoc (!calc_list,op_))) 
	     handle _ => error ("calculate_: "^op_^" not known");
  in case get_calculation_ thy isaop ct of
       None => None
     | Some (thmID, thm) => 
	 (let val Some (rew,_) = rewrite_ thy tless_true e_rls false thm ct
	  in Some (rew,(thmID, thm)) end)
	    handle _ => error ("calculate_: "^thmID^" does not rewrite")
  end;
(*
> val thy = InsSort.thy;
> val op_ = "le";      (* < *)
> val ct = (the o (parse thy)) 
   "foldr ins [#2] (if #1 < #3 then #1 # ins [] #3 else [#3, #1])";
> calculate_ thy op_ ct;
  Some
    ("foldr ins [#2] (if True then #1 # ins [] #3 else [#3, #1])",
     "(#1 < #3) = True") : (cterm * thm) option  *)


(* for test-printouts:
val _ = writeln("in rew_sub  : "^( Sign.string_of_term (sign_of thy) t))
val _ = writeln("in eval_true_: prems= "^(commas (map (Sign.string_of_term (sign_of thy)) prems')))
*)






fun get_rls_scr rs' = ((#scr o rep_rls o the o assoc') (!ruleset',rs'))
  handle _ => raise error ("get_rls_scr: no script for "^rs');


(*make_thm added to Pure/thm.ML*)
fun mk_thm thy str = make_thm (cterm_of (sign_of thy) (Trueprop $ 
			       (term_of o the o (parse thy)) str));
(*prints subgoal etc. 
((goal thy);(topthm()) o ) str;                      *)
(*assume rejects scheme variables 
  assume (cterm_of (sign_of thy) (Trueprop $ 
		(term_of o the o (parse thy)) str)); *)


(* outcommented 18.11. -------
fun rul2rul' (Thm (thmid, thm)) = Thm'(thmid, string_of_thm thm)
  | rul2rul' (Calc op_)         = Calc' op_;
fun rul'2rul thy (Thm'(thmid, ct')) = 
       Thm (thmid, mk_thm thy ct')
  | rul'2rul thy' (Calc' op_)        = Calc op_;


fun rls2rls' (Rls{preconds=preconds,rew_ord=rew_ord,rules=rules}:rls) =
  Rls'{preconds'= map string_of_cterm preconds,
       rew_ord' = fst rew_ord,
       rules'   = map rul2rul' rules}:rlsdat';

fun rls'2rls thy' (Rls'{preconds'=preconds,rew_ord'=rew_ord,
		   rules'=rules}:rlsdat') =
  let val thy = the (assoc' (theory',thy'))
  in Rls{preconds = map (the o (parse thy)) preconds,
	 rew_ord  = (rew_ord, the (assoc'(rew_ord',rew_ord))),
	 rules    = map (rul'2rul thy) rules}:rls end;

fun assoc_rls (thy':theory') ((rlsid, rlsdat'):rls') = 
    if (hd o explode) rlsid = "#" 
	then Some (rls'2rls thy' rlsdat')
    else assoc (ruleset'(*the global value*), rlsid);
------- *)

fun assoc_thm' (thy:theory) ((thmid, ct'):thm') =
    (case explode thmid of
	"s"::"y"::"m"::"_"::id => 
	if hd id = "#" 
	then mk_thm thy ct'
	else (get_thm thy (implode id)) RS sym
      | id => 
	if hd id = "#" 
	then mk_thm thy ct'
	else get_thm thy thmid
	     ) handle _ => 
		      raise error ("assoc_thm': '"^thmid^"not in '"^
				   (theory2domID thy)^"' (and parents)");
(*> assoc_thm' Isac.thy ("sym_#mult_2_3","6 = 2 * 3");
val it = "6 = 2 * 3" : thm          

> assoc_thm' Isac.thy ("real_add_zero_left","");
val it = "0 + ?z = ?z" : thm

> assoc_thm' Isac.thy ("sym_real_add_zero_left","");
val it = "?t = 0 + ?t"  [.] : thm

> assoc_thm' HOL.thy ("sym_real_add_zero_left","");
*** Unknown theorem(s) "real_add_zero_left"
*** assoc_thm': 'sym_real_add_zero_leftnot in 'HOL.thy' (and parents)
 
uncaught exception ERROR*)


fun parse' (thy:theory') (ct:cterm') =
    case parse ((the o assoc')(!theory',thy)) ct of
	None => None
      | Some ct => Some ((string_of_cterm ct):cterm');


(*FIXME 12.8.02: put_asm = true <==> rewrite_inst, rewrite_set_inst
  thus the argument put_asm  IS NOT NECESSARY -- FIXME        ~~~~~*)
fun rewrite (thy':theory') (rew_ord:rew_ord') (rls:rls') 
    (put_asm:bool) (thm:thm') (ct:cterm') =
    let val thy = (the o assoc')(!theory',thy');
    in
    case rewrite_ thy
	((the o assoc')(!rew_ord',rew_ord)) ((the o assoc')(!ruleset',rls))
	put_asm ((assoc_thm' thy) thm)
	((term_of o the o (parse thy)) ct) of
	None => None
      | Some (t, ts) => Some (Sign.string_of_term (sign_of thy) t,
			map (Sign.string_of_term (sign_of thy)) ts)
    end;

(*
val thy     = "RatArith.thy";
val rew_ord = "tless_true"; 
val rls     = "eval_rls";
val put_asm = true; 
val thm     = ("square_equation_left","");
val ct      = "sqrt(#9+#4*x)=sqrt x + sqrt(#-3+x)";

val Zthy     = ((the o assoc')(!theory',thy));
val Zrew_ord = ((the o assoc')(!rew_ord',rew_ord)); 
val Zrls     = ((the o assoc')(!ruleset',rls));
val Zput_asm = put_asm; 
val Zthm     = ((the o (assoc'_thm' thy)) thm);
val Zct      = ((the o (parse ((the o assoc')(!theory',thy)))) ct);

rewrite_ Zthy Zrew_ord Zrls Zput_asm Zthm Zct;

 use"Isa99/interface_ME_ISA.sml";
*)

(*FIXME 12.8.02: put_asm = true <==> rewrite_inst, rewrite_set_inst
  thus the argument put_asm  IS NOT NECESSARY -- FIXME        ~~~~~*)
fun rewrite_set (thy':theory') (erls:rls') (put_asm:bool)
    (rls:rls') (ct:cterm') =
    let val thy = (the o assoc')(!theory',thy');
    in
    case rewrite_set_ thy 
      ((the o assoc')(!ruleset',erls)) put_asm ((the o assoc')(!ruleset',rls))
    ((term_of o the o (parse thy)) ct) of
	None => None
      | Some (t, ts) => Some (Sign.string_of_term (sign_of thy) t,
			map (Sign.string_of_term (sign_of thy)) ts)
    end;

(*evaluate list-expressions
  should work on term, and stand in Isa99/rewrite-parse.sml, 
  but there list_rls <- eval_binop is not yet defined*)
fun eval_listexpr' ct = 
    let val rew = rewrite_set "ListG.thy" "eval_rls" false "list_rls" ct;
    in case rew of 
	   Some (res,_) => res
	 | None => ct end;
fun eval_listexpr_ thy t = 
    let val rew = rewrite_set_ thy ((the o assoc')(!ruleset',"eval_rls")) 
			       false ((the o assoc')(!ruleset',"list_rls")) t;
    in case rew of 
	   Some (res,_) => res
	 | None => t end;


fun get_calculation' (thy:theory') op_ (ct:cterm') =
   case get_calculation_ ((the o assoc')(!theory',thy)) op_
    ((term_of o the o (parse ((the o assoc')(!theory',thy)))) ct) of
	None => None
      | Some (thmid, thm) => 
	    Some ((thmid, string_of_thm thm):thm');

fun calculate (thy':theory') op_ (ct:cterm') =
    let val thy = (the o assoc')(!theory',thy');
    in
	case calculate_ thy op_
			((term_of o the o (parse thy)) ct) of
	    None => None
	  | Some (ct,(thmID,thm)) => 
	    Some (Sign.string_of_term (sign_of thy) ct, 
		  (thmID, string_of_thm thm):thm')
    end;
(*
fun instantiate'' thy' subs ((thmid,ct'):thm') = 
  let val thmid_ = implode ("#"::(explode thmid))  (*see type thm'*)
  in (thmid_, (string_of_thm o (read_instantiate subs)) 
      ((the o (assoc_thm' thy')) (thmid_,ct'))):thm' end;

fun instantiate_rls' thy' subs (rls:rls') = 
    rls2rls' (instantiate_rls subs ((the o (assoc_rls thy')) rls)):rlsdat';

... problem with these functions: 
> val thm = mk_thm thy "(bdv + a = b) = (bdv = b - a)";
val thm = "(bdv + a = b) = (bdv = b - a)" : thm
> show_types:=true; thm;    
val it = "((bdv::'a) + (a::'a) = (b::'a)) = (bdv = b - a)" : thm
... and this doesn't match because of too general typing (?!)
    and read_insitantiate doesn't instantiate the types (?!)
=== solutions:
(1) hard-coded type-instantiation ("'a", "RatArith.rat")
(2) instantiate', instantiate ... no help by isabelle-users@ !!!
=== conclusion:
    rewrite_inst, rewrite_set_inst circumvent the problem,
    according functions out-commented with 'instantiate''
*)

(* instantiate''
fun instantiate'' thy' subs ((thmid,ct'):thm') = 
  let 
    val thmid_ = implode ("#"::(explode thmid));  (*see type thm'*)
    val thy = (the o assoc')(!theory',thy');
    val typs = map (#T o rep_cterm o the o (parse thy)) 
      ((snd o split_list) subs);
    val ctyps = map 
      ((ctyp_of (sign_of thy)) o #T o rep_cterm o the o (parse thy)) 
      ((snd o split_list) subs);

> val thy' = "RatArith.thy";
> val subs = [("bdv","x::rat"),("zzz","z::nat")];
> (the o (parse ((the o assoc')(!theory',thy')))) "x::rat";
> (#T o rep_cterm o the o (parse ((the o assoc')(!theory',thy'))));

> val ctyp = ((ctyp_of (sign_of thy)) o #T o rep_cterm o the o 
	      (parse ((the o assoc')(!theory',thy')))) "x::rat";
> val bdv = (the o (parse thy)) "bdv";
> val x   = (the o (parse thy)) "x";
> (instantiate ([(("'a",0),ctyp)],[(bdv,x)]) isolate_bdv_add)
      handle e => print_exn e;
uncaught exception THM
  raised at: thm.ML:1085.18-1085.69
             thm.ML:1092.34
             goals.ML:536.61

> val bdv = (the o (parse thy)) "bdv::nat";
> val x   = (the o (parse thy)) "x::nat";
> (instantiate ([(("'a",0),ctyp)],[(bdv,x)]) isolate_bdv_add)
      handle e => print_exn e;
uncaught exception THM
  raised at: thm.ML:1085.18-1085.69
             thm.ML:1092.34
             goals.ML:536.61

> (instantiate' [Some ctyp] [] isolate_bdv_add)
      handle e => print_exn e;      
uncaught exception TYPE
  raised at: drule.ML:613.13-615.44
             goals.ML:536.61

> val repct = (rep_cterm o the o (parse ((the o assoc')(!theory',thy')))) "x::rat";
*)

(*FIXME 12.8.02: put_asm = true <==> rewrite_inst, rewrite_set_inst
  thus the argument put_asm  IS NOT NECESSARY -- FIXME        ~~~~~*)
fun rewrite_inst (thy':theory') (rew_ord:rew_ord') (rls:rls') 
  (put_asm:bool) subs (thm:thm') (ct:cterm') =
  let
    val thy = (the o assoc')(!theory',thy');
    val subthm = read_instantiate subs ((assoc_thm' thy) thm)
  in
    case rewrite_ thy
      ((the o assoc')(!rew_ord',rew_ord)) ((the o assoc')(!ruleset',rls))
      put_asm subthm ((term_of o the o (parse thy)) ct) of
      None => None
    | Some (ctm, ctms) => 
      Some ((Sign.string_of_term (sign_of thy) ctm):cterm',
	    (map (Sign.string_of_term (sign_of thy)) ctms):cterm' list)
  end;

(*FIXME 12.8.02: put_asm = true <==> rewrite_inst, rewrite_set_inst
  thus the argument put_asm  IS NOT NECESSARY -- FIXME        ~~~~~*)
fun rewrite_set_inst (thy':theory') (erls:rls') (put_asm:bool)
  subs (rls:rls') (ct:cterm') =
  let
    val thy = (the o assoc')(!theory',thy');
    val subrls = instantiate_rls subs ((the o assoc')(!ruleset',rls))
  in
      case rewrite_set_ thy 
			((the o assoc')(!ruleset',erls)) put_asm subrls
			((term_of o the o (parse thy)) ct) of
	  None => None
	| Some (t, ts) => Some (Sign.string_of_term (sign_of thy) t,
				map (Sign.string_of_term (sign_of thy)) ts)
  end;


fun eval_true thy ts rls =
    case eval_true_ thy ts rls of
	(TRUE, _) => true 
      | _ => false;

(*vor check_elementwise: SqRoot_eval_rls .. wie *_simplify ?! TODO *)
fun eval_true' (thy':theory') (rls':rls') (Const ("True",_)) = true

  | eval_true' (thy':theory') (rls':rls') (t:term) =
(* val thy'="Isac.thy"; val rls'="eval_rls"; val t=hd pres';
   *)
    let val ct' = Sign.string_of_term (sign_of thy) t;
    in case rewrite_set thy' rls' false rls' ct' of
	   Some ("True",_) => true
	 | _ => false 
    end;

(*
val test_rls = 
  Rls{preconds = [], rew_ord = ("sqrt_right",sqrt_right), 
      rules = [Calc ("matches",eval_matches "")
	       ],
      scr = Script ((term_of o the o (parse thy)) 
      "empty_script")
      }:rls;      



  rewrite_set_ Isac.thy eval_rls false test_rls 
        ((the o (parse thy)) "matches (?a = ?b) (x = #0)");
  val xxx = (term_of o the o (parse thy)) 
	       "matches (?a = ?b) (x = #0)";
  eval_matches """" xxx thy;
Some ("matches (?a = ?b) (x + #1 + #-1 * #2 = #0) = True",
     Const ("Trueprop","bool => prop") $ (Const # $ (# $ #) $ Const (#,#)))



  rewrite_set_ Isac.thy eval_rls false eval_rls 
        ((the o (parse thy)) "contains_root (sqrt #0)");
val it = Some ("True",[]) : (cterm * cterm list) option



    
*)
