(* use"ME/appl.sml";
   *)
val e_cterm' = empty_cterm';

val e_rew_ord = dummy_ord;
rew_ord' := overwritel (!rew_ord',
[("e_rew_ord", e_rew_ord)]);

(*bis 10.9.02 verwendet (nur cancel_binom)----------------------------*)
fun rew_info (Rls {asm_thm, erls,rew_ord=(rew_ord',_),calc=ca, ...}) =
    (rew_ord':rew_ord',erls,asm_thm,ca)
  | rew_info (Rrls {asm_thm, erls,rew_ord=(rew_ord',_),calc=ca, ...}) =
    (rew_ord',erls,asm_thm,ca);

(*FIXME.3.4.03:re-organize from_pblobj_or_detail_thm after rls' --> rls*)
fun from_pblobj_or_detail_thm thm' p pt = 
    let val (pbl,p',rls') = par_pbl_det pt p
    in if pbl
       then let (*val _= writeln("### from_pblobj_or_detail_thm: pbl=true")*)
	        val thy' = get_obj g_domID pt p'
		val {rew_ord',erls,asm_thm,...} = 
		    get_met (get_obj g_metID pt p')
		val put_asm = (fst thm') mem (map fst asm_thm)
		(*val _= writeln("### from_pblobj_or_detail_thm: metID= "^
			       (metID2str(get_obj g_metID pt p')))
		val _= writeln("### from_pblobj_or_detail_thm: erls= "^erls)*)
	    in ("OK",thy',rew_ord',erls,put_asm) 
	    end
       else ((*writeln("### from_pblobj_or_detail_thm: pbl=false");*)
	     (*case assoc(!ruleset', rls') of  !!!FIXME.3.4.03:re-organize !!!
		None => ("unknown ruleset '"^rls'^"'","","",Erls,false)
	      | Some rls =>*)
		let val thy' = get_obj g_domID pt (par_pblobj pt p)
		    val (rew_ord',erls,asm_thm,_) = rew_info rls'
		    val put_asm = (fst thm') mem (map fst asm_thm);
		in ("OK",thy',rew_ord',erls,put_asm) end)
    end;
(*FIXME.3.4.03:re-organize from_pblobj_or_detail_calc after rls' --> rls*)
fun from_pblobj_or_detail_calc scrop p pt = 
    let val (pbl,p',rls') = par_pbl_det pt p
    in if pbl
       then let val thy' = get_obj g_domID pt p'
		val {calc = scr_isa_fns,...} = 
		    get_met (get_obj g_metID pt p')
		val opt = assoc (scr_isa_fns, scrop)
	    in case opt of
		   Some isa_fn => ("OK",thy',isa_fn)
		 | None => ("applicable_in Calculate: unknown '"^scrop^"'",
			    "",("",e_evalfn)) end
       else (*case assoc(!ruleset', rls') of
		None => ("unknown ruleset '"^rls'^"'","",("",e_evalfn))
	      | Some rls => !!!FIXME.3.4.03:re-organize from_pblobj_or_detai*)
		(* val Some rls = assoc(!ruleset', rls');
		   *)
		let val thy' = get_obj g_domID pt (par_pblobj pt p);
		    val (_,_,_,scr_isa_fns) = rew_info rls'(*rls*)
		in case assoc (scr_isa_fns, scrop) of
		   Some isa_fn => ("OK",thy',isa_fn)
		 | None => ("applicable_in Calculate: unknown '"^scrop^"'",
			    "",("",e_evalfn)) end
    end;
(*------------------------------------------------------------------*)

val op_and = Const ("op &", [bool, bool] ---> bool);
(*> cterm_of (sign_of thy) (op_and $ Free("a",bool) $ Free("b",bool));
val it = "a & b" : cterm
*)
fun mk_and a b = op_and $ a $ b;
(*> cterm_of (sign_of thy) 
     (mk_and (Free("a",bool)) (Free("b",bool)));
val it = "a & b" : cterm*)

fun mk_and [] = HOLogic.true_const
  | mk_and (t::[]) = t
  | mk_and (t::ts) = 
    let fun mk t' (t::[]) = op_and $ t' $ t
	  | mk t' (t::ts) = mk (op_and $ t' $ t) ts
    in mk t ts end;
(*> val pred = map (term_of o the o (parse thy)) 
             ["#0 <= #9 + #4 * x","#0 <= sqrt x + sqrt (#-3 + x)"];
> cterm_of (sign_of thy) (mk_and pred);
val it = "#0 <= #9 + #4 * x & #0 <= sqrt x + sqrt (#-3 + x)" : cterm*)




(*for Check_elementwise in applicable_in: [x=1,..] Assumptions -> (x,0<=x&..)*)
fun mk_set thy pt p (Const ("List.list.Nil",_)) pred = 
  (e_term, HOLogic.true_const)
(* val pred = (term_of o the o (parse thy)) pred;
   val consts as Const ("List.list.Cons",_) $ eq $ _ = ft;
   mk_set thy pt p consts pred;
   *)
  | mk_set thy pt p (consts as Const ("List.list.Cons",_) $ eq $ _) pred =
  let val (bdv,_) = HOLogic.dest_eq eq;
    val pred = if pred <> Const ("Script.Assumptions",bool)
		 then pred 
	       else (mk_and o (map (term_of o the o (parse thy))) o 
		     (map fst)) (get_obj g_asm pt (par_pblobj pt p)) 
  in (bdv, pred) end
  | mk_set thy _ _ l _ = 
  raise error ("check_elementwise: no set "^
		 (Sign.string_of_term (sign_of thy) l));
(*> val consts = (term_of o the o (parse thy)) "[x=#4]";
> val pred = (term_of o the o (parse thy)) "Assumptions";
> val pt = union_asm pt p 
   [("#0 <= sqrt x + sqrt (#5 + x)",[11]),("#0 <= #9 + #4 * x",[22]),
   ("#0 <= x ^^^ #2 + #5 * x",[33]),("#0 <= #2 + x",[44])];
> val p = [];
> val (sss,ttt) = mk_set thy pt p consts pred;
> (Sign.string_of_term (sign_of thy) sss,Sign.string_of_term(sign_of thy) ttt);
val it = ("x","((#0 <= sqrt x + sqrt (#5 + x) & #0 <= #9 + #4 * x) & ...*)



(*check a list (/set) of constants [c_1,..,c_n] for c_i:set (: in)*)
(* val (erls,consts,(bdv,pred)) = (erl,ft,vp);
   *)
fun check_elementwise thy erls (consts:term) (bdv:term, pred:term) =
  let 
    fun check thy pred ss' [] = ss'
      | check thy pred ss' (s::ss) =
      if eval_true_ (string_of_thy thy) erls (subst_atomic [s] pred)
	then check thy pred (ss' @ [s]) ss
      else check thy pred ss' ss;
    val c' = isalist2list consts;
    val c'' = map (snd o HOLogic.dest_eq) c'; (*assumes [x=1,x=2,..]*)
    val subs = map (pair bdv) c'';
    (*val _= writeln("### check_ele: consts= "^
		       (Sign.string_of_term (sign_of thy) consts));*)
    (*val _= writeln("### check_ele: bdv   = "^
		       (Sign.string_of_term (sign_of thy) bdv));*)
    (*val _= writeln("### check_ele: pred  = "^
		       (Sign.string_of_term (sign_of thy) pred));*)
  in ((list2isalist bool) o (map HOLogic.mk_eq) o (map (pair bdv)) o 
      (map snd))(check thy pred [] subs) end;

(*
val s::ss = subs;
val s::_  = ss;

 val xxx = check thy pred [] subs;
   trace_rewrite:=true;
   trace_rewrite:=false;
   *)
(*
> val ct = "((#0 <= #18 & #0 <= sqrt (#5 + #3) + sqrt (#5 - #3)) &\
	   \ #0 <= #25 + #-1 * #3 ^^^ #2) & #0 <= #4";
> val Some(ct',_) = rewrite_set "Isac.thy" false "eval_rls" ct;
val ct' = "True" : cterm'

> val ct = "((#0 <= #18 & #0 <= sqrt (#5 + #-3) + sqrt (#5 - #-3)) &\
	   \ #0 <= #25 + #-1 * #-3 ^^^ #2) & #0 <= #4";
> val Some(ct',_) = rewrite_set "Isac.thy"  false "eval_rls" ct;
val ct' = "True" : cterm'


> val const  = (term_of o the o (parse thy)) "(#3::real)";
> val pred' = subst_atomic [(bdv,const)] pred;


> val consts = (term_of o the o (parse thy)) "[x = #-3, x = #3]";
> val bdv    = (term_of o the o (parse thy)) "(x::real)";
> val pred   = (term_of o the o (parse thy)) 
  "((#0 <= #18 & #0 <= sqrt (#5 + x) + sqrt (#5 - x)) & #0 <= #25 + #-1 * x ^^^ #2) & #0 <= #4";
> val ttt = check_elementwise thy consts (bdv, pred);
> cterm_of (sign_of thy) ttt;
val it = "[x = #-3, x = #3]" : cterm

> val consts = (term_of o the o (parse thy)) "[x = #4]";
> val bdv    = (term_of o the o (parse thy)) "(x::real)";
> val pred   = (term_of o the o (parse thy)) 
 "#0 <= sqrt x + sqrt (#5 + x) & #0 <= #9 + #4 * x & #0 <= x ^^^ #2 + #5 * x & #0 <= #2 + x";
> val ttt = check_elementwise thy consts (bdv,pred);
> cterm_of (sign_of thy) ttt;
val it = "[x = #4]" : cterm

> val consts = (term_of o the o (parse thy)) "[x = #-12 // #5]";
> val bdv    = (term_of o the o (parse thy)) "(x::real)";
> val pred   = (term_of o the o (parse thy))
 " #0 <= sqrt x + sqrt (#-3 + x) & #0 <= #9 + #4 * x & #0 <= x ^^^ #2 + #-3 * x & #0 <= #6 + x";
> val ttt = check_elementwise thy consts (bdv,pred);
> cterm_of (sign_of thy) ttt;
val it = "[]" : cterm*)


(* 14.1.01: for Mstep-dummies in root-equ only: skip str until "("*)
fun split_dummy str = 
let fun scan s' [] = (implode s', "")
      | scan s' (s::ss) = if s=" " then (implode s', implode  ss)
			  else scan (s'@[s]) ss;
in ((scan []) o explode) str end;
(* split_dummy "subproblem_equation_dummy (x=-#5//#12)";
val it = ("subproblem_equation_dummy","(x=-#5//#12)") : string * string
> split_dummy "x=-#5//#12";
val it = ("x=-#5//#12","") : string * string*)




(* applicability of an mstep wrt ptree and pos 
   (containing the form, msteps should be applied to);
   returns the _current_ pos, !!! _NO_ 12.4.00: pos of given formula !!!
   where the newly created formula should be written to
   ('hard' by generate1, ev.modified in generate by script
8.01:
   for Rewrite...: calculates all what needed for generate1 (True for asm?)
   for SubProblem: what needed for generate1 must come from script (assy)
*)
fun applicable_in (_:pos') _ (Init_Proof (ct', spec)) =
  Appl (Init_Proof' (ct', spec))

  | applicable_in (p,p_) _ (Model_Problem pblID) = 
  if p_ mem [Frm,Res]                  
    then Notappl ((mstep2str (Model_Problem pblID))^
	   " not for pos "^(pos'2str (p,p_)))
  else Appl (Model_Problem' pblID)
(* val Refine_Tacitly pI = m;
   *)
  | applicable_in (p,p_) pt (Refine_Tacitly pI) = 
  if p_ mem [Frm,Res]                  
    then Notappl ((mstep2str (Refine_Tacitly pI))^
	   " not for pos "^(pos'2str (p,p_)))
  else (* val Refine_Tacitly pI = m;
          *)
    let val (PblObj {origin = (oris, (dI',_,_)), ...}) = get_obj I pt p;
      val opt = refine_ori oris pI;
    in case opt of
	   Some pblID => Appl (Refine_Tacitly' (pI, pblID))
	 | None => Notappl ((mstep2str (Refine_Tacitly pI))^
			    " not applicable") end
(* val Refine_Problem pI = m;
   *)
  | applicable_in (p,p_) pt (Refine_Problem pI) = 
  if p_ mem [Frm,Res]                  
    then Notappl ((mstep2str (Refine_Problem pI))^
	   " not for pos "^(pos'2str (p,p_)))
  else
    let val (PblObj {origin=(_,(dI,_,_)),spec=(dI',_,_),
		     probl=itms, ...}) = get_obj I pt p;
	val thy = if dI' = e_domID then dI else dI';
	val ms = refine_pbl (assoc_thy thy) pI itms;
    in if refined ms = pI
       then Notappl ((mstep2str (Refine_Problem pI))^" not applicable")
       else Appl (Refine_Problem' ms) end

  (*the specify-msteps have cterm' instead term: 
   parse+error here!!!: see appl_add*)  
  | applicable_in (p,p_) _ (Add_Given ct') = 
  if p_ mem [Frm,Res]                  
    then Notappl ((mstep2str (Add_Given ct'))^
	   " not for pos "^(pos'2str (p,p_)))
  else Appl (Add_Given' ct')
  (*Add_.. should reject (dsc //) (see fmz=[] in sqrt*)

  | applicable_in (p,p_) _ (Del_Given ct') =
  if p_ mem [Frm,Res]                  
    then Notappl ((mstep2str (Del_Given ct'))^
	   " not for pos "^(pos'2str (p,p_)))
  else Appl (Del_Given' ct')

  | applicable_in (p,p_) _ (Add_Find ct') =                   
  if p_ mem [Frm,Res]                  
    then Notappl ((mstep2str (Add_Find ct'))^
	   " not for pos "^(pos'2str (p,p_)))
  else Appl (Add_Find' ct')

  | applicable_in (p,p_) _ (Del_Find ct') =
  if p_ mem [Frm,Res]                  
    then Notappl ((mstep2str (Del_Find ct'))^
	   " not for pos "^(pos'2str (p,p_)))
  else Appl (Del_Find' ct')

  | applicable_in (p,p_) _ (Add_Relation ct') =               
  if p_ mem [Frm,Res]                  
    then Notappl ((mstep2str (Add_Relation ct'))^
	   " not for pos "^(pos'2str (p,p_)))
  else Appl (Add_Relation' ct')

  | applicable_in (p,p_) _ (Del_Relation ct') =
  if p_ mem [Frm,Res]                  
    then Notappl ((mstep2str (Del_Relation ct'))^
	   " not for pos "^(pos'2str (p,p_)))
  else Appl (Del_Relation' ct')

  | applicable_in (p,p_) _ (Specify_Domain dI) =              
  if p_ mem [Frm,Res]                  
    then Notappl ((mstep2str (Specify_Domain dI))^
	   " not for pos "^(pos'2str (p,p_)))
  else Appl (Specify_Domain' dI)
(* val (p,p_) = p; val Specify_Problem pID = m;
   *)
  | applicable_in (p,p_) pt (Specify_Problem pID) = 
  if p_ mem [Frm,Res]                  
    then Notappl ((mstep2str (Specify_Problem pID))^
	   " not for pos "^(pos'2str (p,p_)))
  else
    let val (PblObj {origin=(oris,(dI,pI,_)),spec=(dI',pI',_),
		     probl=itms, ...}) = get_obj I pt p;
	val thy = assoc_thy (if dI' = e_domID then dI else dI');
        val {ppc,where_,prls,...} = get_pbt pID;
	val pbl = if pI'=e_pblID andalso pI=e_pblID
		  then (false, (init_pbl ppc, []))
		  else match_itms_oris thy itms (ppc,where_,prls) oris;
    in Appl (Specify_Problem' (pID, pbl)) end
(* val Specify_Method mID = nxt; val (p,p_) = p; 
   *)
  | applicable_in (p,p_) pt (Specify_Method mID) =              
  if p_ mem [Frm,Res]               
    then Notappl ((mstep2str (Specify_Method mID))^
	   " not for pos "^(pos'2str (p,p_)))
  else Appl (Specify_Method' mID)

  | applicable_in (p,p_) _ (Apply_Method mI) =                
  if p_ mem [Frm,Res]                  
    then Notappl ((mstep2str (Apply_Method mI))^
	   " not for pos "^(pos'2str (p,p_)))
  else Appl (Apply_Method' mI)

  | applicable_in (p,p_) pt (Check_Postcond pI) =
  if p_ mem [Pbl,Met]                  
    then Notappl ((mstep2str (Check_Postcond pI))^
	   " not for pos "^(pos'2str (p,p_)))
  else Appl (Check_Postcond' (pI,e_term))
  (* in solve -"- gets for       ^^^^ the return-value of script*)

  | applicable_in (p,p_) _ (Free_Solve) = Appl (Free_Solve')

(*20.8.02 FIXXXXXME insert/cut ptree: to be decided in applicable_in*)
(* val m as Rewrite_Inst (subs, thm') = m;
   *)
  | applicable_in (p,p_) pt (m as Rewrite_Inst (subs, thm')) = 
  if p_ mem [Pbl,Met] 
    then Notappl ((mstep2str m)^" not for pos "^(pos'2str (p,p_)))
  else
  let 
    val pp = par_pblobj pt p;
    val thy' = (get_obj g_domID pt pp):theory';
    val {rew_ord'=rew_ord',erls=erls,asm_thm=asm_thm,...} = 
      get_met (get_obj g_metID pt pp);
    val put_asm = (fst thm') mem (map fst asm_thm);
    val (f,p) = case p_ of (*p 12.4.00 unnecessary*)
              Frm => (get_obj g_form pt p, p)
	    | Res => (get_obj g_result pt p, lev_on p)
	    | _ => raise error ("applicable_in: call by "^
				(pos'2str (p,p_)));
  in 
    let val subst = subs2subst (assoc_thy thy') subs;
	val subs' = subst2subs' subst;
    in case rewrite_inst thy' rew_ord' (id_rls erls) 
			 put_asm subs' thm' f of
      Some (f',asm) => Appl (
	  Rewrite_Inst' (thy',rew_ord',erls,put_asm,subst,thm',
      (term_of o the o (parse (assoc_thy thy'))) f,
       ((term_of o the o (parse (assoc_thy thy'))) f',
	map (term_of o the o (parse (assoc_thy thy'))) asm)))
    | None => Notappl ((fst thm')^" not applicable") end
  handle _ => Notappl ("syntax error in "^(subs2str subs)) end

(* val ((p,p_),m as Rewrite thm') = (p,nx);

   val m as Rewrite thm' = m;
   *)
| applicable_in (p,p_) pt (m as Rewrite thm') = 
  if p_ mem [Pbl,Met] 
    then Notappl ((mstep2str m)^" not for pos "^(pos'2str (p,p_)))
  else
  let 
      (*val _= writeln("### applicable_in Rewrite");*)
    val (msg,thy',rew_ord',rls',put_asm) = from_pblobj_or_detail_thm thm' p pt;
    val f = case p_ of (*27.8.02 (f,p) = ... p discarded*)
              Frm => get_obj g_form pt p
	    | Res => get_obj g_result pt p
	    | _ => raise error ("applicable_in Rewrite: call by "^
				(pos'2str (p,p_)));
  in if msg = "OK" 
     then
      ((*writeln("### applicable_in rls'= "^rls');*)
       case rewrite thy' rew_ord' (id_rls rls') put_asm thm' f of
       Some (f',asm) => Appl (
	   Rewrite' (thy',rew_ord',rls',put_asm,thm',
      (term_of o the o (parse (assoc_thy thy'))) f,
		     ((term_of o the o (parse (assoc_thy thy')))f',
	map (term_of o the o (parse (assoc_thy thy'))) asm)))
     | None => Notappl ("'"^(fst thm')^"' not applicable") )
     else Notappl msg
  end

| applicable_in (p,p_) pt (m as Rewrite_Asm thm') = 
  if p_ mem [Pbl,Met] 
    then Notappl ((mstep2str m)^" not for pos "^(pos'2str (p,p_)))
  else
  let 
    val pp = par_pblobj pt p; 
    val thy' = (get_obj g_domID pt pp):theory';
    val {rew_ord'=rew_ord',erls=erls,...} = 
      get_met (get_obj g_metID pt pp);
    val put_asm = true;
    val (f,p) = case p_ of  (*p 12.4.00 unnecessary*)
              Frm => (get_obj g_form pt p, p)
	    | Res => (get_obj g_result pt p, lev_on p)
	    | _ => raise error ("applicable_in: call by "^
				(pos'2str (p,p_)));
  in case rewrite thy' rew_ord' (id_rls erls) put_asm thm' f of
       Some (f',asm) => Appl (
	   Rewrite' (thy',rew_ord',erls,put_asm,thm',
      (term_of o the o (parse (assoc_thy thy'))) f,
		     ((term_of o the o (parse (assoc_thy thy')))f',
	map (term_of o the o (parse (assoc_thy thy'))) asm)))
     | None => Notappl ("'"^(fst thm')^"' not applicable") end
(* val (m as Rewrite_Set_Inst (subs, rls))=m;
  *)
  | applicable_in (p,p_) pt (m as Rewrite_Set_Inst (subs, rls)) = 
  if p_ mem [Pbl,Met] 
    then Notappl ((mstep2str m)^" not for pos "^(pos'2str (p,p_)))
  else
  let 
    val pp = par_pblobj pt p;
    val thy' = (get_obj g_domID pt pp):theory';
    val {rew_ord'=rew_ord',asm_rls=asm_rls,...} = 
      get_met (get_obj g_metID pt pp);
    val put_asm = rls mem asm_rls;
    val (f,p) = case p_ of  (*p 12.4.00 unnecessary*)
              Frm => (get_obj g_form pt p, p)
	    | Res => (get_obj g_result pt p, lev_on p)
	    | _ => raise error ("applicable_in: call by "^
				(pos'2str (p,p_)));
  in 
    let val subst = subs2subst (assoc_thy thy') subs;
	val subs' = subst2subs' subst;
    in case rewrite_set_inst thy' put_asm subs' rls f of
      Some (f',asm) => Appl (
	  Rewrite_Set_Inst' (thy',put_asm,subst,assoc_rls rls,
      (term_of o the o (parse (assoc_thy thy'))) f,
			     ((term_of o the o (parse (assoc_thy thy')))f',
	map (term_of o the o (parse (assoc_thy thy'))) asm)))
    | None => Notappl (rls^" not applicable") end
  handle _ => Notappl ("syntax error in "^(subs2str subs)) end

  | applicable_in (p,p_) pt (m as Rewrite_Set rls) = 
  if p_ mem [Pbl,Met] 
    then Notappl ((mstep2str m)^" not for pos "^(pos'2str (p,p_)))
  else
  let 
    val pp = par_pblobj pt p; 
    val thy' = (get_obj g_domID pt pp):theory';
    val {asm_rls=asm_rls,...} = get_met (get_obj g_metID pt pp);
    val put_asm = rls mem asm_rls;
    val (f,p) = case p_ of  (*p 12.4.00 unnecessary*)
              Frm => (get_obj g_form pt p, p)
	    | Res => (get_obj g_result pt p, lev_on p)
	    | _ => raise error ("applicable_in: call by "^
				(pos'2str (p,p_)));
  in case rewrite_set thy' put_asm rls f of
       Some (f',asm) => 
	((*writeln("#.# applicable_in Rewrite_Set,2f'= "^f');*)
	 Appl (Rewrite_Set' (thy',put_asm,assoc_rls rls,
			   (term_of o the o (parse (assoc_thy thy'))) f,
			   ((term_of o the o (parse (assoc_thy thy'))) f',
			    map(term_of o the o(parse (assoc_thy thy')))asm)))
	 )
     | None => Notappl (rls^" not applicable") end

  | applicable_in (p,p_) pt (m as Detail) = 
    if p_ mem [Pbl,Met] 
    then Notappl ("Detail not YET impl. for pos "^(pos'2str (p,p_)))
    else
	(case get_obj g_mstep pt p of
	     Rewrite_Set rls =>
	     let
		 val thy' = get_obj g_domID pt (par_pblobj pt p)
		 val f = (term_of o the o (parse (assoc_thy thy'))) 
			     (get_obj g_form pt p);
	     in Appl (Detail_Set'(thy', assoc_rls rls, f)) end
	   | Rewrite_Set_Inst(*append*) (subs,rls) =>
	     let
		 val thy' = get_obj g_domID pt (par_pblobj pt p)
		 val f = (term_of o the o (parse (assoc_thy thy'))) 
			     (get_obj g_form pt p);
		 val subst = subs2subst (assoc_thy thy') subs;
	     in Appl (Detail_Set_Inst'(thy', subst, assoc_rls rls, f)) end
	   | _ => Notappl ("Detail not YET impl. for "^
			   (mstep2str (get_obj g_mstep pt p))))

  | applicable_in (p,p_) pt (m as End_Detail) = 
    if p_ mem [Pbl,Met,Frm] 
    then Notappl ("applicable_in: End_Detail not for pos "^(pos'2str (p,p_)))
    else (case get_obj g_mstep pt (lev_up p) of
	      Detail_Set _ => 
	      Appl (End_Detail' ((term_of o the o 
				  (parse (assoc_thy "Isac.thy")))
				     (get_obj g_result pt p)))
	    | _ => Notappl "applicable_in: End_Detail not in a Detail-branch")

  | applicable_in p pt (End_Ruleset) = 
  raise error ("applicable_in: not impl. for "^
	       (mstep2str End_Ruleset))

(* val Calculate op_ = m;
   *)
| applicable_in (p,p_) pt (m as Calculate op_) = 
  if p_ mem [Pbl,Met] 
    then Notappl ((mstep2str m)^" not for pos "^(pos'2str (p,p_)))
  else
  let 
    val (msg,thy',isa_fn) = from_pblobj_or_detail_calc op_ p pt;
    val f = case p_ of
              Frm => get_obj g_form pt p
	    | Res => get_obj g_result pt p
  in if msg = "OK" then
	 case calculate thy' isa_fn f of
	     Some (f',thm') => 
	     Appl (Calculate' (thy',op_, 
			       (term_of o the o (parse (assoc_thy thy'))) f,
			       ((term_of o the o (parse (assoc_thy thy')))f', 
				thm')))
	   | None => Notappl ("'calculate "^op_^"' not applicable") 
     else Notappl msg
  end

  | applicable_in (p,p_) pt (m as Substitute subs) = 
  if p_ mem [Pbl,Met] 
    then Notappl ((mstep2str m)^" not for pos "^(pos'2str (p,p_)))
  else
    let 
    val pp = par_pblobj pt p;
    val thy' = (get_obj g_domID pt pp):theory';
    val (f,p) = case p_ of  (*p 12.4.00 unnecessary*)
              Frm => (get_obj g_form pt p, p)
	    | Res => (get_obj g_result pt p, lev_on p)
	    | _ => raise error ("applicable_in: call by "^
				(pos'2str (p,p_)));
      val ft = (term_of o the o (parse (assoc_thy thy'))) f;
    in 
      let val subst = subs2subst (assoc_thy thy') subs;
	  val subs' = subst2subs' subst;
	  val f' = subst_atomic subst ft;
      in if ft = f' 
	   then Notappl ((subs2str subs)^" not applicable")
	 else Appl (Substitute' (subst, ft, f')) end
       handle _ => Notappl ("syntax error in "^(subs2str subs)) end

  | applicable_in p pt (Apply_Assumption cts') = 
  (raise error ("applicable_in: not impl. for "^
	       (mstep2str (Apply_Assumption cts'))))
  
  (*'logical' applicability wrt. script in locate: Inconsistent?*)
  | applicable_in (p,p_) pt (m as Take ct') = 
     if p_ mem [Pbl,Met] 
       then Notappl ((mstep2str m)^" not for pos "^(pos'2str (p,p_)))
     else
       let val thy' = get_obj g_domID pt (par_pblobj pt p);
       in (case parse (assoc_thy thy') ct' of
	       Some ct => Appl (Take' (term_of ct))
	     | None => Notappl ("syntax error in "^ct'))
       end

  | applicable_in p pt (Take_Inst ct') = 
  raise error ("applicable_in: not impl. for "^
	       (mstep2str (Take_Inst ct')))

  | applicable_in p pt (Group (con, ints)) = 
  raise error ("applicable_in: not impl. for "^
	       (mstep2str (Group (con, ints))))
(*1.8.01---
  | applicable_in (p,p_) pt (m as Subproblem (spec, cts')) = 
     if p_ mem [Pbl,Met] 
       then Notappl ((mstep2str m)^" not for pos "^(pos'2str (p,p_)))
     else 
       let val thy' = get_obj g_domID pt (par_pblobj pt p);
       in ((Appl (Subproblem'(spec, 
	  map(term_of o the o(parse (assoc_thy thy')))cts')))
	   handle _ => Notappl ("syntax error in "^(strs2str cts')))
       end
----*)
  | applicable_in (p,p_) pt (m as Subproblem (domID, pblID)) = 
     if p_ mem [Pbl,Met] 
       then Notappl ((mstep2str m)^" not for pos "^(pos'2str (p,p_)))
     else 
       Appl (Subproblem' ((domID, pblID, e_metID), [], subpbl domID pblID))

  | applicable_in p pt (End_Subproblem) =
  raise error ("applicable_in: not impl. for "^
	       (mstep2str (End_Subproblem)))

  | applicable_in p pt (CAScmd ct') = 
  raise error ("applicable_in: not impl. for "^
	       (mstep2str (CAScmd ct')))
  
  | applicable_in p pt (Split_And) = 
  raise error ("applicable_in: not impl. for "^
	       (mstep2str (Split_And)))
  | applicable_in p pt (Conclude_And) = 
  raise error ("applicable_in: not impl. for "^
	       (mstep2str (Conclude_And)))
  | applicable_in p pt (Split_Or) = 
  raise error ("applicable_in: not impl. for "^
	       (mstep2str (Split_Or)))
  | applicable_in p pt (Conclude_Or) = 
  raise error ("applicable_in: not impl. for "^
	       (mstep2str (Conclude_Or)))

  | applicable_in (p,p_) pt (Begin_Trans) =
    let
      val (f,p) = case p_ of   (*p 12.4.00 unnecessary*)
	                             (*_____ implizit Take in gen*)
	Frm => (get_obj g_form pt p, (lev_on o lev_dn) p)
      | Res => (get_obj g_result pt p, (lev_on o lev_dn o lev_on) p)
      | _ => raise error ("applicable_in: call by "^
				(pos'2str (p,p_)));
      val thy' = get_obj g_domID pt (par_pblobj pt p);
    in (Appl (Begin_Trans' ((term_of o the o (parse (assoc_thy thy'))) f)))
      handle _ => raise error ("applicable_in: Begin_Trans finds \
                               \syntaxerror in '"^f^"'") end
    (*TODO: check parent branches*)
  | applicable_in (p,p_) pt (End_Trans) =
    let val thy' = get_obj g_domID pt (par_pblobj pt p);
    in if p_ = Res 
	   then Appl (End_Trans' ((term_of o the o (parse (assoc_thy thy'))) 
				  (get_obj g_result pt p)))
       else Notappl "'End_Trans' is not applicable at \
	\the beginning of a transitive sequence"
	 (*TODO: check parent branches*)
    end

  | applicable_in p pt (Begin_Sequ) = 
  raise error ("applicable_in: not impl. for "^
	       (mstep2str (Begin_Sequ)))
  | applicable_in p pt (End_Sequ) = 
  raise error ("applicable_in: not impl. for "^
	       (mstep2str (End_Sequ)))
  | applicable_in p pt (Split_Intersect) = 
  raise error ("applicable_in: not impl. for "^
	       (mstep2str (Split_Intersect)))
  | applicable_in p pt (End_Intersect) = 
  raise error ("applicable_in: not impl. for "^
	       (mstep2str (End_Intersect)))
(* val Check_elementwise pred = m; val (p,p_) = p;
   
   val Check_elementwise pred = m;

   val Appl (Check_elementwise'(t1,"Assumptions",t2)) = it;
   val (vvv,ppp) = vp;
   *)
  | applicable_in (p,p_) pt (Check_elementwise pred) = 
  let 
    val pp = par_pblobj pt p; 
    val thy' = (get_obj g_domID pt pp):theory';
    val thy = assoc_thy thy'
    val metID = (get_obj g_metID pt pp)
    val {erls,...} =  get_met metID
    (*val _=writeln("### applicable_in Check_elementwise: erls= "^erls)
    val _=writeln("### applicable_in Check_elementwise: pred= "^pred)*)
    (*val erl = the (assoc'(!ruleset',erls))*)
    val f = case p_ of
              Frm => get_obj g_form pt p
	    | Res => get_obj g_result pt p;
    val ft = (term_of o the o (parse thy)) f;
    (*val _= writeln("### applicable_in Check_elementwise: f= "^f);*)
    val vp = mk_set thy pt p ft ((term_of o the o (parse thy)) pred);
    (*val (v,p)=vp;val _=writeln("### applicable_in Check_elementwise: vp= "^
			       pair2str(term2str v,term2str p))*)
  in case ft of
      Const ("List.list.Cons",_) $ _ $ _ =>
	Appl (Check_elementwise'
		  (ft, pred, 
		   ((*writeln("### applicable_in Check_elementwise: --> "^
			    (term2str (check_elementwise thy erl ft vp)));*)
		   check_elementwise thy erls ft vp)))
    | Const ("List.list.Nil",_) => Notappl "not applicable to empty list"
    | _ => Notappl ("not applicable: "^f^" should be constants")
  end

  | applicable_in (p,p_) pt Or_to_List = 
  let 
    val pp = par_pblobj pt p; 
    val thy' = (get_obj g_domID pt pp):theory';
    val thy = assoc_thy thy';
    val f = case p_ of
              Frm => get_obj g_form pt p
	    | Res => get_obj g_result pt p;
    val ft = (term_of o the o (parse thy)) f;
  in (let val ls = or2list ft
      in Appl (Or_to_List' (ft, ls)) end) 
     handle _ => Notappl ("'Or_to_List' not applicable to "^f)
  end

  | applicable_in p pt (Collect_Trues) = 
  raise error ("applicable_in: not impl. for "^
	       (mstep2str (Collect_Trues)))

  | applicable_in p pt (Empty_Mstep) = 
  Notappl "Empty_Mstep is not applicable"

  | applicable_in (p,p_) pt (Mstep id) = 
  let 
    val pp = par_pblobj pt p; 
    val thy' = (get_obj g_domID pt pp):theory';
    val thy = assoc_thy thy';
    val f = case p_ of
              Frm => get_obj g_form pt p
	    | Res => get_obj g_result pt p;
  in case id of
      "subproblem_equation_dummy" =>
	  if is_expliceq ((term_of o the o (parse thy)) f)
	      then Appl (Mstep' (thy,f,id,"subproblem_equation_dummy ("^f^")"))
	  else Notappl "applicable only to equations made explicit"
    | "solve_equation_dummy" =>
	  let (*val _= writeln("### applicable_in: solve_equation_dummy: f= "
				 ^f);*)
	    val (id',f') = split_dummy f;
	    (*val _= writeln("### applicable_in: f'= "^f');*)
	    (*val _= (term_of o the o (parse thy)) f';*)
	    (*val _= writeln"### applicable_in: solve_equation_dummy";*)
	  in if id' <> "subproblem_equation_dummy" then Notappl "no subproblem"
	     else if is_expliceq ((term_of o the o (parse thy)) f')
		      then Appl (Mstep' (thy,f, id, "[" ^ f' ^ "]"))
		  else error ("applicable_in: f= " ^ f') end
    | _ => Appl (Mstep' (thy,f, id, f)) end



  | applicable_in p pt End_Proof' = Appl End_Proof''

  | applicable_in _ _ m = 
  raise error ("applicable_in called for "^(mstep2str m));

fun mstep2mstep' pt p m = 
    case applicable_in p pt m of
	Appl (m') => m' 
      | Notappl _ => raise error ("mstep2mstp': fails with"^
				  (mstep2str m));

