(* testexamples for PolyEq, poynomial equations and equational systems
   use"kbtest/polyeq.sml";
   use"polyeq.sml";

   *)

"-------------- tests on predicates in problems ---------------------------";
"----------------------test matching problems -----------------------------";
"-------------------- (-8 - 2*x + x^^^2 = 0),  (*Schalk 2, S.67 Nr.31.b-----";
"-------------------- (-16 + 4*x + 2*x^^^2 = 0), ----------------------";
"-------------------- (a*b - (a+b)*x + x^^^2 = 0), (*Schalk 2, S.68 Nr.44.a*)";
"-------------------- (-64 + x^^^2 = 0), (*Schalk 2, S.66 Nr.1.a~--------*)";
"-------------------- (-147 + 3*x^^^2 = 0), (*Schalk 2, S.66 Nr.1.b--------*)";

"---- (3*x - 1 - (5*x - (2 - 4*x)) = -11),(*Schalk I s.86 Bsp 5-------------*)";
"((x+1)*(x+2) - (3*x - 2)^^^2=(2*x - 1)^^^2+(3*x - 1)*(x+1)),(*Schal II s.68 Bsp 37*)";


"-------------- tests on predicates in problems ---------------------------";
"-------------- tests on predicates in problems ---------------------------";
"-------------- tests on predicates in problems ---------------------------";
(* Compiler.Control.Print.printDepth:=5; (*4 default*)
 trace_rewrite:=true;
 trace_rewrite:=false;
*)
 val t1 = (term_of o the o (parse thy)) "lhs (-8 - 2*x + x^^^2 = 0)";
 val Some (t,_) = rewrite_set_ PolyEq.thy false polyeq_prls t1;
 if ((term2str t) = "-8 - 2 * x + x ^^^ 2") then ()
 else  raise error "polyeq.sml: diff.behav. in lhs";


 val t2 = (term_of o the o (parse thy)) "(-8 - 2*x + x^^^2) is_expanded_in x";
 val Some (t,_) = rewrite_set_ PolyEq.thy false polyeq_prls t2;
 if (term2str t) = "True" then ()
 else  raise error "polyeq.sml: diff.behav. in is_expended_in";

 val t0 = (term_of o the o (parse thy)) "(sqrt(x)) is_poly_in x";
 val Some (t,_) = rewrite_set_ PolyEq.thy false polyeq_prls t0;
 if (term2str t) = "False" then ()
 else  raise error "polyeq.sml: diff.behav. in is_poly_in";


 val t3 = (term_of o the o (parse thy)) "(-8 + (-1)*2*x + x^^^2) is_poly_in x";
 val Some (t,_) = rewrite_set_ PolyEq.thy false polyeq_prls t3;
 if (term2str t) = "True" then ()
 else  raise error "polyeq.sml: diff.behav. in is_poly_in";


 val t4 = (term_of o the o (parse thy)) "(lhs (-8 + (-1)*2*x + x^^^2 = 0)) is_expanded_in x";
 val Some (t,_) = rewrite_set_ PolyEq.thy false polyeq_prls t4;
 if (term2str t) = "True" then ()
 else  raise error "polyeq.sml: diff.behav. in is_expended_in";


 val t6 = (term_of o the o (parse thy)) "(lhs (-8 - 2*x + x^^^2 = 0)) is_expanded_in x";
 val Some (t,_) = rewrite_set_ PolyEq.thy false polyeq_prls t6;
 if (term2str t) = "True" then ()
 else  raise error "polyeq.sml: diff.behav. in is_expended_in";
 
 val t3 = (term_of o the o (parse thy))"((-8 - 2*x + x^^^2) has_degree_in x) = 2";
 val Some (t,_) = rewrite_set_ PolyEq.thy false polyeq_prls t3;
 if (term2str t) = "2 = 2" then ()
 else  raise error "polyeq.sml: diff.behav. in has_degree_in_in";


 val t3 = (term_of o the o (parse thy)) "((sqrt(x)) has_degree_in x) = 2";
 val Some (t,_) = rewrite_set_ PolyEq.thy false polyeq_prls t3;
 if (term2str t) = "-1 = 2" then ()
 else  raise error "polyeq.sml: diff.behav. in has_degree_in_in";

 val t4 = (term_of o the o (parse thy)) 
	      "((-8 - 2*x + x^^^2) has_degree_in x) = 1";
 val Some (t,_) = rewrite_set_ PolyEq.thy false polyeq_prls t4;
 if (term2str t) = "2 = 1" then ()
 else  raise error "polyeq.sml: diff.behav. in has_degree_in_in";


 val t5 = (term_of o the o (parse thy)) 
	      "((-8 - 2*x + x^^^2) has_degree_in x) =!= 2";
 val Some (t,_) = rewrite_set_ PolyEq.thy false polyeq_prls t5;
 if (term2str t) = "True" then ()
 else  raise error "polyeq.sml: diff.behav. in has_degree_in_in";

"----------------------test matching problems -----------------------------";
"----------------------test matching problems -----------------------------";
"----------------------test matching problems -----------------------------";
 val fmz = ["equality (-8 - 2*x + x^^^2 = 0)", "solveFor x","solutions L"];
 val pbt as {thy = thy, where_ = pre, ppc = ppc,...} =
     get_pbt ["expanded","univariate","equation"];
 
 match_pbl fmz (get_pbt ["expanded","univariate","equation"]);
 (*Matches'
    {Find=[Correct "solutions L"],
     Given=[Correct "equality (-8 - 2 * x + x ^^^ 2 = 0)",
            Correct "solveFor x"],Relate=[],
     Where=[Correct "matches (?a = 0) (-8 - 2 * x + x ^^^ 2 = 0)",
            Correct "lhs (-8 - 2 * x + x ^^^ 2 = 0) is_expanded_in x"],With=[]}
 *)
 match_pbl fmz (get_pbt ["degree_2","expanded","univariate","equation"]);
 (*Matches'
    {Find=[Correct "solutions L"],
     Given=[Correct "equality (-8 - 2 * x + x ^^^ 2 = 0)",
            Correct "solveFor x"],Relate=[],
     Where=[Correct "lhs (-8 - 2 * x + x ^^^ 2 = 0) has_degree_in x =!= 2"],
     With=[]}*)


"-------------------- (-8 - 2*x + x^^^2 = 0),  (*Schalk 2, S.67 Nr.31.b-----";
"-------------------- (-8 - 2*x + x^^^2 = 0),  (*Schalk 2, S.67 Nr.31.b-----";
"-------------------- (-8 - 2*x + x^^^2 = 0),  (*Schalk 2, S.67 Nr.31.b-----";
 val fmz = ["equality (-8 - 2*x + x^^^2 = 0)", (*Schalk 2, S.67 Nr.31.b*)
 	    "solveFor x","solutions L"];
 val (dI',pI',mI') =
     ("PolyEq.thy",["degree_2","expanded","univariate","equation"],
      ("PolyEq.thy","complete_square"));
 val p = e_pos'; val c = []; 
 val (mI,m) = ("Init_Proof",Init_Proof (fmz, (dI',pI',mI')));
 val (p,_,f,nxt,_,pt) = me (mI,m) p c EmptyPtree;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 (*Apply_Method ("PolyEq.thy","complete_square")*)
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 (*"-8 - 2 * x + x ^^^ 2 = 0", nxt = Rewrite_Set_Inst ... "complete_square*)
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 (*"-8 + (2 / 2 - x) ^^^ 2 = (2 / 2) ^^^ 2", nxt = Rewrite("square_explicit1"*)
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 (*"(2 / 2 - x) ^^^ 2 = (2 / 2) ^^^ 2 - -8" nxt = Rewrite("root_plus_minus*)
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 (*"2 / 2 - x = sqrt ((2 / 2) ^^^ 2 - -8) |
    2 / 2 - x = - sqrt ((2 / 2) ^^^ 2 - -8)" nxt = Rewr_Inst("bdv_explicit2"*)
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 (*"2 / 2 - x = sqrt ((2 / 2) ^^^ 2 - -8) |
    -1*x = - (2 / 2) + - sqrt ((2 / 2) ^^^ 2 - -8)"nxt = R_Inst("bdv_explt2"*)
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 (*"-1 * x = - (2 / 2) + sqrt ((2 / 2) ^^^ 2 - -8) |
    -1 * x = (- (2 / 2) + - sqrt ((2 / 2) ^^^ 2 - -8))"nxt = bdv_explicit3*)
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 (*"-1 * x = - (2 / 2) + sqrt ((2 / 2) ^^^ 2 - -8) |
   x = -1 * (- (2 / 2) + - sqrt ((2 / 2) ^^^ 2 - -8))" nxt = bdv_explicit3*)
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 (*"x = -1 * (- (2 / 2) + sqrt ((2 / 2) ^^^ 2 - -8)) |
    x = -1 * (- (2 / 2) + - sqrt ((2 / 2) ^^^ 2 - -8))"nxt = calculate_Ration*)
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 (*"x = -2 | x = 4" nxt = Or_to_List*)
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 (*"[x = -2, x = 4]" nxt = Check_Postcond*)
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
(* FIXXX ME
 case f of Form' (FormKF (~1,EdUndef,0,Nundef,"[x = -2, x = 4]")) => ()
	 | _ => raise error "polyeq.sml: diff.behav. in [x = -2, x = 4]";
*)

"-------------------- (3 - 10*x + 3*x^^^2 = 0), ----------------------";
"-------------------- (3 - 10*x + 3*x^^^2 = 0), ----------------------";
"-------------------- (3 - 10*x + 3*x^^^2 = 0), ----------------------";
"---- test the erls ----";
 val t1 = (term_of o the o (parse thy)) "0 <= (10/3/2)^^^2 - 1";
 val Some (t,_) = rewrite_set_ PolyEq.thy false polyeq_erls t1;
 val t' = term2str t;
 (*if t'= "True" then ()
 else raise error "polyeq.sml: diff.behav. in 'rewrite_set_.. polyeq_erls";*)
(* *)
 val fmz = ["equality (3 - 10*x + 3*x^^^2 = 0)",
 	    "solveFor x","solutions L"];
 val (dI',pI',mI') =
     ("PolyEq.thy",["degree_2","expanded","univariate","equation"],
      ("PolyEq.thy","complete_square"));
 val p = e_pos'; val c = []; 
 val (mI,m) = ("Init_Proof",Init_Proof (fmz, (dI',pI',mI')));
 val (p,_,f,nxt,_,pt) = me (mI,m) p c EmptyPtree;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 (*Apply_Method ("PolyEq.thy","complete_square")*)
 val (p,_,f,nxt,_,pt) = me nxt p c pt;

"-------------------- (-16 + 4*x + 2*x^^^2 = 0), ----------------------";
"-------------------- (-16 + 4*x + 2*x^^^2 = 0), ----------------------";
"-------------------- (-16 + 4*x + 2*x^^^2 = 0), ----------------------";
 val fmz = ["equality (-16 + 4*x + 2*x^^^2 = 0)",
 	    "solveFor x","solutions L"];
 val (dI',pI',mI') =
     ("PolyEq.thy",["degree_2","expanded","univariate","equation"],
      ("PolyEq.thy","complete_square"));
 val p = e_pos'; val c = []; 
 val (mI,m) = ("Init_Proof",Init_Proof (fmz, (dI',pI',mI')));
 val (p,_,f,nxt,_,pt) = me (mI,m) p c EmptyPtree;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 (*Apply_Method ("PolyEq.thy","complete_square")*)
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
(* FIXXXX ME
 case f of Form' (FormKF (~1,EdUndef,0,Nundef,"[x = 2, x = -4]")) => ()
	 | _ => raise error "polyeq.sml: diff.behav. in [x = 2, x = -4]";
*)

"-------------------- (a*b - (a+b)*x + x^^^2 = 0), (*Schalk 2, S.68 Nr.44.a*)";
"-------------------- (a*b - (a+b)*x + x^^^2 = 0), (*Schalk 2, S.68 Nr.44.a*)";
"-------------------- (a*b - (a+b)*x + x^^^2 = 0), (*Schalk 2, S.68 Nr.44.a*)";
 val fmz = ["equality (a*b - (a+b)*x + x^^^2 = 0)",(*Schalk 2, S.68 Nr.44.a*)
 	    "solveFor x","solutions L"];
 val (dI',pI',mI') =
     ("PolyEq.thy",["degree_2","expanded","univariate","equation"],
      ("PolyEq.thy","complete_square"));
 val p = e_pos'; val c = []; 
 val (mI,m) = ("Init_Proof",Init_Proof (fmz, (dI',pI',mI')));
 val (p,_,f,nxt,_,pt) = me (mI,m) p c EmptyPtree;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;

 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 case f of 
     Form' 
	 (FormKF 
	      (~1,EdUndef,0,Nundef,
	       "[x = (a + b) / 2 + -1 * sqrt ((a + b) ^^^ 2 / 2 ^^^ 2 - a * b),\n x = (a + b) / 2 + sqrt ((a + b) ^^^ 2 / 2 ^^^ 2 - a * b)]")) 
	 => ()
   | _ => raise error "polyeq.sml: diff.behav. in a*b - (a+b)*x + x^^^2 = 0";
 (*this will be simplified [x = a, x = b] to by Factor.ML*)


"-------------------- (-64 + x^^^2 = 0), (*Schalk 2, S.66 Nr.1.a~--------*)";
"-------------------- (-64 + x^^^2 = 0), (*Schalk 2, S.66 Nr.1.a~--------*)";
"-------------------- (-64 + x^^^2 = 0), (*Schalk 2, S.66 Nr.1.a~--------*)";
 val fmz = ["equality (-64 + x^^^2 = 0)",(*Schalk 2, S.66 Nr.1.a~*)
 	    "solveFor x","solutions L"];
 val (dI',pI',mI') =
     ("PolyEq.thy",["degree_2","expanded","univariate","equation"],
      ("PolyEq.thy","complete_square"));
 val p = e_pos'; val c = []; 
 val (mI,m) = ("Init_Proof",Init_Proof (fmz, (dI',pI',mI')));
 val (p,_,f,nxt,_,pt) = me (mI,m) p c EmptyPtree;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 case f of Form' (FormKF (~1,EdUndef,0,Nundef,"[x = 8, x = -8]")) => ()
	 | _ => raise error "polyeq.sml: diff.behav. in [x = 8, x = -8]";


"-------------------- (-147 + 3*x^^^2 = 0), (*Schalk 2, S.66 Nr.1.b--------*)";
"-------------------- (-147 + 3*x^^^2 = 0), (*Schalk 2, S.66 Nr.1.b--------*)";
"-------------------- (-147 + 3*x^^^2 = 0), (*Schalk 2, S.66 Nr.1.b--------*)";
 val fmz = ["equality (-147 + 3*x^^^2 = 0)",(*Schalk 2, S.66 Nr.1.b*)
 	    "solveFor x","solutions L"];
 val (dI',pI',mI') =
     ("PolyEq.thy",["degree_2","expanded","univariate","equation"],
      ("PolyEq.thy","complete_square"));
 val p = e_pos'; val c = []; 
 val (mI,m) = ("Init_Proof",Init_Proof (fmz, (dI',pI',mI')));
 val (p,_,f,nxt,_,pt) = me (mI,m) p c EmptyPtree;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 val (p,_,f,nxt,_,pt) = me nxt p c pt;
 case f of Form' (FormKF (~1,EdUndef,0,Nundef,"[x = 7, x = -7]")) => ()
	 | _ => raise error "polyeq.sml: diff.behav. in [x = 7, x = -7]";



"---- (3*x - 1 - (5*x - (2 - 4*x)) = -11),(*Schalk I s.86 Bsp 5-------------*)";
"---- (3*x - 1 - (5*x - (2 - 4*x)) = -11),(*Schalk I s.86 Bsp 5-------------*)";
"---- (3*x - 1 - (5*x - (2 - 4*x)) = -11),(*Schalk I s.86 Bsp 5-------------*)";
val fmz = ["equality (3*x - 1 - (5*x - (2 - 4*x)) = -11)","solveFor x","solutions L"];
(* refine fmz ["univariate","equation"];
*)
val (dI',pI',mI') = ("PolyEq.thy",["univariate","equation"],("PolyEq.thy","no_met"));
val p = e_pos'; 
val c = []; 
val (mI,m) = ("Init_Proof",Init_Proof (fmz, (dI',pI',mI')));
val (p,_,f,nxt,_,pt) = me (mI,m) p c EmptyPtree;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(* val nxt =
  ("Model_Problem",
   Model_Problem ["normalize","polynomial","univariate","equation"])
  : string * mstep*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(* val nxt =
  ("Subproblem",
   Subproblem ("PolyEq.thy",["polynomial","univariate","equation"]))
  : string * mstep *)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*val nxt =
  ("Model_Problem",
   Model_Problem ["degree_1","polynomial","univariate","equation"])
  : string * mstep *)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
case f of Form' (FormKF (~1,EdUndef,0,Nundef,"[x = 2]")) => ()
	 | _ => raise error "polyeq.sml: diff.behav. in [x = 2]";
(* [x = 2] *)

(*-----------------  Schal II s.68 Bsp 37 ------------------------*)
"Schal II s.68 Bsp 37 ((x+1)*(x+2) - (3*x - 2)^^^2=(2*x - 1)^^^2+(3*x - 1)*(x+1)) ";
"Schal II s.68 Bsp 37 ((x+1)*(x+2) - (3*x - 2)^^^2=(2*x - 1)^^^2+(3*x - 1)*(x+1)) ";
"Schal II s.68 Bsp 37 ((x+1)*(x+2) - (3*x - 2)^^^2=(2*x - 1)^^^2+(3*x - 1)*(x+1)) ";
val fmz = ["equality ((x+1)*(x+2) - (3*x - 2)^^^2=(2*x - 1)^^^2+(3*x - 1)*(x+1))",
	   "solveFor x","solutions L"];
val (dI',pI',mI') = ("PolyEq.thy",["univariate","equation"],("PolyEq.thy","no_met"));
val p = e_pos'; 
val c = []; 
val (mI,m) = ("Init_Proof",Init_Proof (fmz, (dI',pI',mI')));
val (p,_,f,nxt,_,pt) = me (mI,m) p c EmptyPtree;
(*val nxt = ("Refine_Tacitly",Refine_Tacitly ["univariate","equation"])*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(* val nxt =
  ("Model_Problem",
   Model_Problem ["normalize","polynomial","univariate","equation"])
  : string * mstep *)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(* val nxt =
  ("Subproblem",
   Subproblem ("PolyEq.thy",["polynomial","univariate","equation"]))
  : string * mstep*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*val nxt =
  ("Model_Problem",
   Model_Problem ["abcFormula","degree_2","polynomial","univariate","equation"])
  : string * mstep*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
case f of Form' (FormKF (~1,EdUndef,0,Nundef,"[x = 2 / 15, x = 1]")) => ()
	 | _ => raise error "polyeq.sml: diff.behav. in [x = 2 / 15, x = 1]";
(* [x = 2 / 15 , x = 1]*)
"----------------- polyeq.sml end ------------------";
val fmz = ["equality ( -4 + x^^^2 =0)", "solveFor x","solutions L"];
(* val fmz = ["equality (1 + x^^^2 =0)", "solveFor x","solutions L"];*)
(*val fmz = ["equality (0 =0)", "solveFor x","solutions L"];*)
val (dI',pI',mI') = ("PolyEq.thy",["univariate","equation"],("PolyEq.thy","no_met"));
val p = e_pos'; 
val c = []; 
val (mI,m) = ("Init_Proof",Init_Proof (fmz, (dI',pI',mI')));
val (p,_,f,nxt,_,pt) = me (mI,m) p c EmptyPtree;

val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(* FIXXX ME applicable_in Check_elementwise:
case f of Form' (FormKF (~1,EdUndef,0,Nundef,"[x = 2, x = -2]")) => ()
	 | _ => raise error "polyeq.sml: diff.behav. in [x = 2, x = -2]";
*)

(*Punkte aus dem TestBericht, die ich in rlang.sml nicht zuordnen konnte:*)
(*WN.19.3.03 ---v-*)
(*3(b)*)val (bdv,v) = (str2term "bdv", str2term "R1");
val t = str2term "-1 * (R * R2) + R2 * R1 + -1 * (R * R1) = 0";
val Some (t',_) = rewrite_set_inst_ thy false [(bdv,v)] make_polynomial_in t;
term2str t';
"-1 * R * R2 + (R2 + -1 * R) * R1 = 0";
(*WN.19.3.03 ---^-*)

(*3(c)*)val (bdv,v) = (str2term "bdv", str2term "p");
val t = str2term "y ^^^ 2 + -2 * (x * p) = 0";
val Some (t',_) = rewrite_set_inst_ thy false [(bdv,v)] make_polynomial_in t;
term2str t';
"y ^^^ 2 + -2 * x * p = 0";

(*3(d)*)val (bdv,v) = (str2term "bdv", str2term "x2");
val t = str2term 
"A + x1 * (y3 * (1 / 2)) + x3 * (y2 * (1 / 2)) + -1 * (x1 * (y2 * (1 / 2))) + -1 * (x3 * (y1 * (1 / 2 ))) + y1 * (1 / 2 * x2) + -1 * (y3 * (1 / 2 * x2)) = 0";
val Some (t',_) = rewrite_set_inst_ thy false [(bdv,v)] make_polynomial_in t;
term2str t';
"A + x1 * y3 * (1 / 2) + x3 * y2 * (1 / 2) + - x1 * y2 * (1 / 2) + - x3 * y1 * (1 / 2) + (y1 * (1 / 2) + - y3 * (1 / 2)) * x2 = 0";
val Some (t',_) = rewrite_set_inst_ thy false [(bdv,v)] make_ratpoly_in t;
term2str t';
"A + x1 * y3 * (1 / 2) + x3 * y2 * (1 / 2) + -1 * x1 * y2 * (1 / 2) + -1 * x3 * y1 * (1 / 2) + (y1 * (1 / 2) + -1 * y3 * (1 / 2)) * x2 = 0";

(*3(e)*)val (bdv,v) = (str2term "bdv", str2term "a");
val t = str2term 
"A ^^^ 2 + c ^^^ 2 * (c / d) ^^^ 2 + (-4 * (c / d) ^^^ 2) * a ^^^ 2 = 0";
val None = rewrite_set_inst_ thy false [(bdv,v)] make_polynomial_in t;
(*die _unsichtbare_ Klammern sind genau wie gew"unscht*)
